/******************************************************************************
**
**			msgparse.c
**
** Function to parse top level SNMP message 
**
**
*****************************************************************************/
#include "../../h/conf.h"
#ifdef BSD
#include <stdio.h>
#endif /* BSD */
#ifdef SVR3WIN
#include <stdio.h>
#endif /* SVR3WIN */
#include "../../h/snmp_hs.h"
#include "../../h/asn.h"

short
msgparse(pktlen,msgbuf,sid,sidlen,version,msglen)
short *pktlen;				/* length of packet */
char *msgbuf;				/* message to be parsed */
char *sid;				/* session id (community) */
short *sidlen;				/* length of session id */
long *version;				/* version */
short *msglen;				/* length of data (PDU) */
{ u_short dlen;				/* length of data */
  char *current;			/* current byte being parsed */
  short buflen;
  char *oldcurrent;
  strng s_id;

/* error checks */
  if(msgbuf == NULL)
   return(NOINBUF);
  if(sid == NULL || sidlen == NULL)
   return(NOSID);
  if(version == NULL || msglen == NULL)
   return(GENERR);
  current = msgbuf;

/* check that we have a sequence here */
  if(*current != SEQID)			/* if not a sequence */
   return(TYP_MISMATCH);
  current++;

/* get length of data */
  if((current = asnlen(pktlen,current,&dlen)) == NULL)
   return(*pktlen);

/* get version */
  buflen = 5;
  oldcurrent = current;
  if((current = prseint(pktlen,current,&buflen,(long *)version)) == NULL)
   return(*pktlen);
  dlen -= (current - oldcurrent);

/* get session id */
  s_id.str = NULL; s_id.len = 0;
  buflen = 128;				/* nonsensical figure */
  oldcurrent = current;
  if((current = prsestr(pktlen,current,&buflen,&s_id)) == NULL)
   return(*pktlen);
  strcpy(sid,s_id.str);
  free(s_id.str);
  *sidlen = s_id.len;
  dlen -= (current - oldcurrent);

/* return with message index and message length */
  *msglen = dlen;
  return(current-msgbuf);
}
  
