void actmgr::deletecomponent(mstring str, listmgr& lmgr, iomgr& io) {
  ipaddr addr, alias, neighbor;
  nametype name;
  commid cid;
  int snmp, comptype, intfc, x, y;
  int addrfound, more, i, deletedfirst;
  gateway *g, *g1;
  LAN *lan, *lan1;
  link *l;
  io.openDialog(24);
  sscanf(str, "%s%s%s", addr, name);
  addrfound = lmgr.findNameAddr(addr, alias, name, cid, snmp, comptype);
  if (strcmp(addr, "none") == 0 && !addrfound) {
    sprintf(str, "Cannot delete - no addr for %s.\n", name);
    io.printline(PRESS, str);
    return;
  }
  if ((g = lmgr.gtwy_find(addr)) == NULLPTR) {
    sprintf(str, "Cannot delete - %s not in network.\n", addr);
    io.printline(PRESS, str);
    return;
  }
  more = g->getfirstneighbor(neighbor);
  while (more) {
    if (strncmp(neighbor, "LAN", 3) == 0) {      /* delete LAN member */
      if ((lan = lmgr.LAN_find(neighbor)) != NULLPTR)
	if ((i = lan->del_member(addr)) > 0) {
	  io.undrawlink(addr, neighbor);
#ifdef DEBUG
	  sprintf(str, "Removed LAN link from %s to %s\n", addr, neighbor);
	  io.printline(NOPRESS, str);
#endif
	}
    }
    else
      if ((l = lmgr.link_find(addr, neighbor)) != NULLPTR)  /* delete link */
	if ((i = lmgr.link_remove(addr, neighbor)) == 0) {
	  io.undrawlink(addr, neighbor);
	  if ((g1 = lmgr.gtwy_find(neighbor)) != NULLPTR)
	    g1->removeneighbor(addr);
#ifdef DEBUG
	  sprintf(str, "Removed link from %s to %s\n", addr, neighbor);
	  io.printline(NOPRESS, str);
#endif
	}
    more = g->getnextneighbor(neighbor);
  }
  sprintf(str, "Deleting %s...\n", addr);
  io.printline(NOPRESS,str);
  i = lmgr.gtwy_remove(addr);
  io.undrawnode(addr);
  lan = lan1 = lmgr.LAN_getfirst();
  deletedfirst = FALSE;
  do {
    if (lan == NULLPTR) break;
    if (lan->getfirstmember(neighbor, intfc, x, y) == 0) {
      if (lan == lan1) deletedfirst = TRUE;
      strcpy(neighbor, lan->getname());
      if ((i = lmgr.LAN_remove(neighbor)) == 0) {
	io.undrawLAN(neighbor);
	sprintf(str, "Deleting %s...\n", neighbor);
	io.printline(NOPRESS, str);
      }
    }
    lan = lmgr.LAN_getnext();
    if (deletedfirst) {
      lan1 = lan;
      deletedfirst = FALSE;
    }
  }
  while(lan != lan1);
  g = g1 = lmgr.gtwy_getfirst();
  deletedfirst = FALSE;
  do {
    if (g == NULLPTR) break;
    if (g->getfirstneighbor(neighbor) == 0) {   /* isolated gtwy - remove */
      if (g == g1) deletedfirst = TRUE;
      strcpy(addr, g->getaddr());
      if ((i = lmgr.gtwy_remove(addr)) == 0) {
	io.undrawnode(addr);
	sprintf(str, "Deleting %s...\n", addr);
	io.printline(NOPRESS, str);
      }
    }
    g = lmgr.gtwy_getnext();
    if (deletedfirst) {
      g1 = g;
      deletedfirst = FALSE;
    }
  }
  while (g != g1);
  sprintf(str, "\nDone deleting...\n");
  io.printline(PRESS, str);
}
