#include <stdio.h>
#include "actmgr.h"
#include <string.h>

#define FORK 1

extern int fork();
extern int system(char*);
extern int wait();

main () {
#ifdef FORK
  int pid;
  pid = fork();
  if (pid > 0) {          /* this is the parent process */
#endif
  listmgr listmanager;
  gateway *g, *gfirst;
  iomgr iomanager;
  actmgr activitymgr;
  int menu1choice, menu2choice, opstat, newopstat;
  mstring msg, filename;    /* char[80] */
  msgstr inputstr;
  int filechanged = FALSE, notdone = TRUE;
  FILE *fp;
  int errno;
  char c;
  do {                   /* poll each gateway for any reqd activity */
    gfirst = listmanager.gtwy_getfirst();
    g = gfirst;
    do {
      if (g != NULL) {
	opstat = g->getopstat();
	if (g->ops_loop(newopstat, msg) != 0) {
	  sprintf(msg, "Error in gateway %s\n", g->getaddr());
	  iomanager.printline(PRESS, msg);
	}
	else
	  if (strlen(msg) > 0) {
	    if (opstat != newopstat) {
	      iomanager.openDialog(5);
	      iomanager.printline(PRESS, msg);
	      iomanager.newStatus(g->getaddr(), g->getsnmp(), newopstat);
	    }
	    else
	      iomanager.printline(LOG, msg);
	  }
	g = listmanager.gtwy_getnext();
      }
    }
    while (g != gfirst);
    menu1choice = iomanager.getnextinput(menu2choice, inputstr);
    switch(menu1choice) {
    case 0:                    /* move */
      if (menu2choice == 0) break;
      switch(menu2choice) {
        case 1: activitymgr.moveNode(inputstr, listmanager); break;
        case 2: activitymgr.moveLAN(inputstr, listmanager); break;
        default: break;
      }
      break;
    case 1:                    /* load */
      if (filechanged && iomanager.savefilefirst(filename)) {
	if ((fp = fopen(filename, "w")) == NULL) {
	  printf("\nWARNING--> can't open savefile - Press RETURN...");
	  c = getchar();
	}
	else {
	  errno = listmanager.savefile(fp);
	  if (errno != 0) {
	    printf("\nWARNING--> Unable to save all output -");
	    printf(" Press RETURN...");
	    c = getchar();
	  }
	  fclose(fp);
	}
      }
      filechanged = FALSE;
      strcpy(filename, inputstr);
      if ((fp = fopen(filename, "r")) == NULL) {
	printf("\nWARNING--> can't open loadfile - Press RETURN...");
	c = getchar();
      }
      else {
	listmanager.removenetwork();
	errno = listmanager.readfile(fp);
	if (errno != 0) {
	  printf("WARNING--> Unable to read all input - ");
	  printf("Press RETURN...");
	  c = getchar();
	}
	fclose(fp);
	activitymgr.drawnetwork(listmanager, iomanager);
      }
      break;
    case 2:                                       /* save */
      if ((fp = fopen(inputstr, "w")) == NULL) {
	printf("\nWARNING--> can't open savefile - Press RETURN...");
	c = getchar();
      }
      else {
	errno = listmanager.savefile(fp);
	if (errno != 0) {
	  printf("WARNING--> Unable to save all output - Press RETURN...");
	  c = getchar();
	}
	fclose(fp);
      }
      filechanged = FALSE;
      break;
    case 3:               /* print */
      switch(menu2choice) {
      case 1: activitymgr.printnodes(listmanager, iomanager);
	break;
      case 2: activitymgr.printlinks(listmanager, iomanager);
	break;
      case 3: activitymgr.printLANs(listmanager, iomanager);
	break;
      default:
	break;
      }
      break;
    case 4:               /* log file handled in iomgr */
      iomanager.logfileOnOff(inputstr);
      break;
    case 5:               /* add component */
      filechanged = TRUE;
      errno = activitymgr.addcomponent(PRINTERRORS, inputstr,
				       listmanager, iomanager);
      break;
    case 6:               /* delete component */
      filechanged = TRUE;
      activitymgr.deletecomponent(inputstr, listmanager, iomanager);
      break;
    case 7:               /* other functions */
      switch(menu2choice) {
      case 1:
	activitymgr.queryone(inputstr, listmanager, iomanager);
	break;
      case 2:
	activitymgr.querymany(inputstr, listmanager, iomanager);
	break;
      case 3:
	activitymgr.monitor(inputstr, listmanager, iomanager);
	break;
      case 4:
	activitymgr.opstat(inputstr, listmanager, iomanager);
	break;
      case 5:
	break;
      case 6:
	filechanged = TRUE;
	activitymgr.map(inputstr, listmanager, iomanager);
	break;
      case 7:
	activitymgr.trace(inputstr, listmanager, iomanager);
	break;
      case 8:
	break;
      default:
	break;
      }
      break;
    case 8:               /* quit */
      listmanager.removenetwork();
      notdone = FALSE;
      break;
    default:
      break;
    }
  }
  while (notdone);
#ifdef FORK
  wait();             /* wait for graphics to finish */
  exit(10);           /* then quit too */
  }
  else {              /* this is the child process */
    system("io");   /* start up the graphics */
    exit(10);
  }
#endif
}
