#include <string.h>
#include <ctype.h>

#define NULLPTR 0

/* 
 * Breaks line up into two parts (if ':' present); makes lower case;
 * removes whitespace. Returns: 0=data:data, 1 = data, 2 = ';', ' ', or ?
 */
int parseline(char *part1, char *part2) {
  char *p1, *p2;
  p1 = part1;
  while ((*p1 == 32) || (*p1 == 9)) p1++;
  strcpy(part1, p1);
  if (!isalnum(*p1)) return 2;                    /* not a data line */
  if ((p2 = strchr(part1,'\n')) != NULLPTR)       /* remove any CR */
    *p2 = '\0';
  p1 = part1;
  for (; p1 < part1 + strlen(part1); p1++)
    if (isupper(*p1)) *p1 = _tolower(*p1);        /* convert to lower case */
  if ((p2 = strchr(part1, ':')) == NULLPTR)
    return 1;                                    /* not gateway data */
  *p2 = '\0';
  p2++;                                          /* ptr to 1st char of par2 */
  p1 = part1;
  while ((*p2 == 32) || (*p2 == 9)) p2++;
  strcpy(part2, p2);
  return 0;
}
