/* pragma optimize -1 */

#include <string.h>
#include "entry.h"

char blanks[62]="                                                            ";
const long decL = 10;

void beep(row, col)
  int row, col;
 {
  move(LINES-1,0);
  addch(7);
  refresh();
  move(LINES-1,0);
  clrtobot();
  move(row,col);
  }

void strins(c, srcstr, pos)
  char c, srcstr[];
  int pos;
  {
  int length;
  for (length = 0; srcstr[length] != '\0'; length++);
  for (; length >= pos; length--)
    {
    srcstr[length+1] = srcstr[length];
    }
  srcstr[pos] = c; 
  }

void strdel(srcstr, strt, nrchar)
  char srcstr[];
  int strt, nrchar;
  {
  while (srcstr[strt] != '\0')
    {
    srcstr[strt] = srcstr[strt + nrchar];
    strt++;
    }
  srcstr[strt] = '\0';
  }

void strpcpy(deststr, srcstr, strt, nrchar)
  char deststr[], srcstr[];
  int strt, nrchar;
  {
  int ctr;
  for (ctr = 0; ctr < nrchar && srcstr[ctr + strt] != '\0'; ctr++)
    deststr[ctr] = srcstr[ctr + strt];
  deststr[ctr] = '\0';
  }

void initialize()
  {
  initscr();
  raw();
  noecho();
  clear();
}

void terminate()
  {
  endwin();
}

static void errmsg(i)
  int i;
  {
  char c;
  beep(LINES-1,0);
  standout();
  addstr("Error");
  standend();
  addstr(" --> ");
  switch (i)
    {
    case 1: addstr("Entry too short.                   ");
            break;
    case 2: addstr("Entry too long.                    ");
            break;
    case 3: addstr("Use MMDDYY date format, e.g. 050390");
            break;
    case 4: addstr("Use + or - and digits 0 to 9 only. ");
            break;
    case 5: addstr("Enter Y/y or N/n only.             ");
            break;
    case 6: addstr("Use +/-, digits 0 to 9, & decimal. ");
            break;
    case 7: addstr("Integer value too large.           ");
            break;
    case 8: addstr("Bad string - too long.             ");
            break;
    default:addstr("An error has occurred.             ");
    }
  addstr("  -  Press key to continue... ");
  refresh();
  c = getch();
  move(LINES - 1, 0);
  clrtobot();
  }

static void help(col, row)
  int col, row;
{
  char c;
  move(LINES-2,0);
  standout();
  addstr("^B");
  standend();
  addstr(": cursor left   ");
  standout();
  addstr("^F");
  standend();
  addstr(": cursor right   ");
  standout();
  addstr("^I");
  standend();
  addstr(": insert space at cursor");
  move(LINES-1, 0);
  standout();
  addstr("^D");
  standend();
  addstr(", ");
  standout();
  addstr("DEL");
  standend();
  addstr(": delete char left   ");
  standout();
  addstr("^X");
  standend();
  addstr(": clear entry     ");
  standout();
  addstr("Press a key to continue ");
  standend();
  refresh();
  c = getch();
  move(LINES - 2, 0);
  clrtobot();
  move(row, col);
  refresh();
}

static void echoprt(s, length, col, row, max)
  char s[];
  int length, col, row, max;
{
  while (length++ < max) strins(' ', s, 0);
  move(row, col);
  addstr(s);
  addch(' ');
  refresh();
}

void LIntToStr(s,l)
  char s[];
  long int l;
  {
  int minus;
  int j = 0;
  s[0] = '\0';
  minus = (l <0);
  if (minus) l = -l;
  if (l == 0) strins('0', s, 0);
  else
    while (l > 0) {
      j = (int)(l % decL) + '0';
      strins(j, s, 0);
      l /= decL;
    }
  if (minus) strins ('-', s, 0);
}

void DblToStr(s, d, max)
  char s[];
  double d;
  int max;
{
  int minus = 0, length = 0, pwr = 0, n;
  if (d < 0.0) {
    minus = 1;
    d = -d;
  }
  if (d < 1.0) {
    s[length++] = '0';
  }
  else {
    while (d >= 10.0) {
      pwr++;
      d /= 10.0;
    }
  }
  for (; length <= pwr; length++) {
    n = (int) d;
    if (n != (int)(d + 0.000000001)) {
      d += 0.000000001;
      n = (int) d;
    }
    s[length] = n + '0';
    d = d - (double) n;
    if (d < 0.0) d = 0.0;
    if (length != pwr) d = d * 10.0;
  }
  s[length++] = '.';
  while ((length < max) && (d > 0.000000001)) {
    d *= 10.0;
    n = (int) d;
    if (n != (int)(d + 0.000000001)) {
      d += 0.000000001;
      n = (int) d;
    }
    s[length] = n + '0';
    length++;
    d = d - (double) n;
    if (d < 0.0) d = 0.0;
    if (minus) {
      strins('-', s, 0);
      length++;
    }
  }
  s[length] = '\0';
}

int StrToInt(s,l)
  char *s;
  long int *l;
  {
  int minus = 1, count = 0;
  *l = 0;
  if (*s == '-') {
    minus = -1;
    *(s++);
  }
  else
    if (*s == '+') 
      *(s++);
  while ((*s != '\0') && (count++ < 20)) {
    if ((*s >= '0') && (*s <= '9'))
      *l = *l * decL + *s - '0';
    else return 0;
    s++;
  }
  *l *= minus;
  return 1;
}

int StrToDbl(s, d)
  char *s;
  double *d;
{
  int count = 0;
  double mult = 0.1, minus = 1.0;
  *d = 0.0;
  if (*s == '-') {
    minus = -1.0;
    s++;
  }
  else
    if (*s == '+') s++;
  while (*s != '\0' && *s != '.' && count++ < 65) {
    if ((*s >= '0') && (*s <= '9'))
      *d = *d * 10.0 + (double)(*s - '0');
    else return 0;
    s++;
  }
  if (count > 60) { 
    errmsg(99);
    return 0;
  }
  if (*s == '\0') {
      *d *= minus;
      return 1;
  }
  else s++;
  count = 0;
  while (*s != '\0' && count++ <= 60) {
    if ((*s >= '0') && (*s <= '9'))
      *d = *d + mult * (double)(*s - '0');
    mult /= 10.0;
    s++;
  }
  *d *= minus;
  return 1;
}

void writeInt(i, w)
  int i, w; 
  {
  char s[20];
  int j, minus, length = 0;
  s[0] = '\0';
  minus = (i < 0);
  if (minus) i = -i;
  if (i == 0)
    {
    strins('0', s, 0);
    length++;
    }
  else
    while (i > 0)
      {
      j = i % 10 + '0';
      strins(j, s, 0);
      i /= 10;
      length++;
      }
  if (minus)
    {
    strins('-', s, 0);
    length++;
    }
  while (length < w)
    {
    strins(' ',s,0);
    length++;
    } 
  addstr(s);
  refresh();
  }

void writeDbl(r, width, nrdec)
  double r;
  int width, nrdec;
  {
  int pwr = 0, minus = 0, length = 0, i, n;
  char s[80];
  if (r < 0.0)
    {
    minus = 1;
    r = -r;
    }
  if (r < 1.0)
    s[length++] = '0';
  else
    {
    while (r >= 10.0)
      {
      r /= 10.0;
      pwr++;
      }
    for (; length <= pwr; length++)
      {
      n = (int) r;
      if (n != (int)(r + 0.00000000001)) {
        r += 0.00000000001;
        n = (int) r;
      }
      s[length] = n + '0';
      r = r - (double)n;
      if (r < 0.0) r = 0.0;
      if (length != pwr)
        r *= 10.0;
      }
    }
  s[length++] = '.';
  for (i = 0; i < nrdec; i++)
    {
    r *= 10.0;
    n = (int) r;
    if (n != (int)(r + 0.00000000001)) {
      r += 0.00000000001;
      n = (int) r;
    }
    s[length++] = n + '0';
    r = r - (double)n;
    if (r < 0.0) r = 0.0;
    }
  if (minus)
    {
    strins('-', s, 0);
    length++;
    }
  while (length < width)
    {
    strins(' ', s, 0);
    length++;
    }
  s[length] = '\0';
  addstr(s);
  refresh();
  }

void writenStr(s, n)
  char *s;
  int n;
  {
  int i;
  for (i = 0; i < n; i++) addch(*(s++));
  refresh();
  }

static void cursorleft(col, row, cursorloc)
  int *col, row, *cursorloc;
  {
  if (*cursorloc > 0)
    {
    *cursorloc -= 1;;
    *col-= 1;
    addch('\b');;
    }
  else
    beep(row, *col);
  }

static void cursorrt(col, row, cursorloc, length)
  int *col, row, *cursorloc, length;
  {
  if (*cursorloc < length)
    {
    (*cursorloc)++;
    (*col)++;
    move(row, *col);
    }
  else
    beep(row, *col);
  }

static void insertspc(s, col, row, cloc, max, length)
  char s[];
  int col, row, cloc, max, *length;
  {
  int i;
  if ((cloc < *length) && (*length < max))
    {
    addch(' ');
    for (i = cloc; i < *length; i++) addch(s[i]);
    *length +=1;
    for (i = *length; i >= cloc+2; i--) s[i-1] = s[i-2];
    s[cloc] = ' ';
    move(row, col);
    }
  else
    beep(row, col);
  }

static void deletechar(s, col, row, cloc, length)
  char s[];
  int *col, row, *cloc, *length;
  {
  int i;
  if (*cloc > 0) {
    if (*cloc == *length) {
      (*col)--;
      addch('\b');
      addch('.');
      addch('\b');
    }
    else {
      (*col)--;
      addch('\b');
      for (i = *cloc; i < *length; i++) {
        addch(s[i]);
        s[i-1] = s[i];
      }
      addch('.');
      move(row, *col);
    }
    *cloc -= 1;
    *length -=1;;
  }
  else
    beep(row, *col);
}

static int queryStr(s, l, form, col, row, min, max)
  char s[];
  long int *l;
  enum entryForm form;
  int col, row, min, max;
  {
  int length, cursorloc, done = 0, startRow, startCol;
  char dots[62];
  char alph;
  strcpy(dots, "............................................................");
  startRow = row;
  startCol = col;
  do {
    if (max > 60) max = 60;
    if ((min < 0) || (min > 60)) min = 0;
    move(startRow,startCol);
    row = startRow;
    if ((form == NEW) || (form == ESCNEW))
      length = 0;
    else {
      length = strlen(s);
      if (length > max)
        length = max;
    }       
    col = startCol + length;
    cursorloc = length;
    s[length] = '\0';
    addstr(s);
    if (length < max) writenStr(dots, max - length);
    move(row, col);
    refresh();
    do {
      alph = getch();
      if ((alph > 31) && (alph < 127) && (alph != 92)) {
        if ((length == max) && (cursorloc == max)) {
          errmsg(2);
          gotoxy(col, row);
        }
        else {
          if (cursorloc == length) length++;
          s[cursorloc++] = alph;
          col++;
          addch(alph);
        }
      }
      else {
        switch (alph) {
          case 2: cursorleft(&col, row, &cursorloc);
                   break;
          case 6:  cursorrt(&col, row, &cursorloc, length);
                   break;
          case 8:;
          case 127:;
          case 4:  deletechar(s, &col, row, &cursorloc, &length);
                   break;
          case 9:  insertspc(s, col, row, cursorloc, max, &length);
                   break;
          case 13: done = 1;
                   break;
          case 27: if ((form == ESCNEW) || (form == ESCEDIT)) {
                     s[length] = '\0';
                     *l = length;
                     return 1;
                   }
                   else beep(row, col);
                   break;
          case 24: form = NEW;
                   break;
          case 1:  help(col, row);
                   break;
          default: beep(row, col);
        }
      }
      refresh();
    }
    while ((!done) && (alph != 24));
    if (length < min) {
      errmsg(1);
      if (form == NEW) form = EDIT;
      else
        if (form == ESCNEW) form = ESCEDIT;
      done = 0;
      s[length] = '\0';
    }
  }
  while (!done);
  s[length] = '\0';
  *l = length;
  return 0;
}

static int getYN(s, l, form, col, row)
  char s[];
  long int *l;
  enum entryForm form;
  int col, row;
{
  int end;
  *l = 1;
  for (;;) {
    end = queryStr(s, l, form, col, row, 1, 1);
    if ((end) && ((form == ESCNEW) || (form == ESCEDIT))) return end;
    if ((s[0] == 'Y') || (s[0] == 'y')) return end;
    if ((s[0] == 'N') || (s[0] == 'n')) {
      *l = 0;
      return end;
    }
    else errmsg(5);
  }
}

static int getDate(s, form, col, row)
  char s[];
  enum entryForm form;
  int col, row;
{
  int escPress, goodDate;
  long int l;
  char dt[3], newdate[9];
  dt[2] = '\0';
  if ((form == ESCNEW) || (form == NEW)) s[0] = '\0';
  strcpy(newdate,s);
  for (;;) {
    goodDate = 1;
    escPress = queryStr(s, &l, form, col, row, 0, 6);
    if ((escPress) && ((form == ESCNEW) || (form == ESCEDIT))) {
      strcpy(s,newdate);
      echoprt(s, 0, col, row, 0);
      return escPress;
    }
    if (l == 6) {
      dt[0] = s[0];
      dt[1] = s[1];
      if (StrToInt(dt, &l) && l < 13 && l > 0) {
        dt[0] = s[2];
        dt[1] = s[3];
        if (StrToInt(dt, &l) && l < 31 && l > 0) {
          dt[0] = s[4];
          dt[0] = s[5];
          if (StrToInt(dt, &l)) {
            strcpy(newdate, s);
            strins('-', newdate, 2);
            strins('-', newdate, 5);
            echoprt(newdate, 8, col, row, 8);
            return 0;
          }
          else goodDate = 0;
        }
        else goodDate = 0;
      }
      else goodDate = 0;
    }
    else goodDate = 0;
    if (!goodDate) {
      errmsg(3);
      if (form == NEW) form = EDIT;
      else
        if (form == ESCNEW) form = ESCEDIT;
    }
  }
}

static int getStr(s, l, form, col, row, min, max)
  char s[];
  long int *l;
  enum entryForm form;
  int col, row, min, max;
{
  int end, bl;
  char ssave[62];
  if (form == ESCEDIT) strcpy(ssave,s);
  else ssave[0] = '\0';
  end = queryStr(s, l, form, col, row, min, max);
  move(row, col);
  if (end) strcpy(s,ssave);
  addstr(s);
  bl = max - (int)strlen(s) + 1;
  strpcpy(ssave, blanks, 0, bl);
  addstr(ssave);
  refresh();
  return end;
}

static int getInt(l, form, col, row, min, max)
  long int *l;
  enum entryForm form;
  int col, row, min, max;
{
  int escPress, length, goodnum;
  long lngth, lsave;
  char s[62], ssave[62];
  if ((form == EDIT) || (form == ESCEDIT)) {
    LIntToStr(s, *l);
    strcpy(ssave,s);
  }
  else {
    *l = 0;
    ssave[0] = '\0';
  }
  lsave = *l;
  do {
    escPress = queryStr(s, &lngth, form, col, row, min, max);
    length = (int)lngth;
    goodnum = StrToInt(s,l);
    if ((escPress) && ((form == ESCNEW) || (form == ESCEDIT))) {
       *l = lsave;
       echoprt(ssave, (int)strlen(ssave), col, row, max);
       return 1;
    }   
    if (!goodnum) {
      if (form == NEW) form = EDIT;
      else
        if (form == ESCNEW) form = ESCEDIT;
      errmsg(4);
      s[length] = '\0';
    }
  }
  while (!goodnum);
  echoprt(s, length, col, row, max);
  return 0;
}

static int getDbl(d, form, col, row, min, max)
  double *d;
  enum entryForm form;
  int col, row, min, max;
{
  int escPress, length, goodnum;
  double dsave;
  long lngth;
  char s[62], ssave[62];
  if ((form == EDIT) || (form == ESCEDIT)) {
    DblToStr(s, *d, max);
    strcpy(ssave, s);
    }
  else {
    *d = 0.0;
    ssave[0] = '\0';
  }
  dsave = *d;
  do {
    escPress = queryStr(s, &lngth, form, col, row, min, max);
    length = (int)lngth;
    goodnum = StrToDbl(s, d);
    if ((escPress) && ((form == ESCNEW) || (form == ESCEDIT))) {
      *d = dsave;
      echoprt(ssave, (int)strlen(ssave), col, row, max);
      return 1;
    }
    if (!goodnum) {
      if (form == NEW) form = EDIT;
      else
        if (form == ESCNEW) form == ESCEDIT;
      errmsg(6);
      s[length] = '\0';
    }
  }
  while (!goodnum);
  echoprt(s, length, col, row, max);
  return 0;
}

int query(s, l, d, form, typ, col, row, min, max)
  char s[];
  long int *l;
  double *d;
  enum entryForm form;
  enum entryType typ;
  int col, row, min, max;
  {
  switch(typ) {
    case YN:   *d = 0.0;
               return getYN(s, l, form, col, row);
               break;
    case DATE: *d = 0.0; *l = 0;
               return getDate(s, form, col, row);
               break;
    case STR:  *d = 0.0;
               return getStr(s, l, form, col, row, min, max);
               break;
    case LINT: s[0] = '\0';
               *d = 0.0;
               return getInt(l, form, col, row, min, max);
               break;
    case DBL:  s[0] = '\0';
               *l = 0;
               return getDbl(d, form, col, row, min, max);
               break;
    default:   return 0;;
  }
}
